function results = ipcm1_transitional(X,F,M,pident,start)
% this is a program to perform ideal point classification model
% for transitional data only with rotational constraint on B.
% (c) Mark de Rooij, 04-09-2007.

% basic reference Bonney (1987) Biometrics
[ni,n]=counti(pident);
ni=ni';nstart = [1; cumsum(ni)+1];
[N1,p] = size(X);
[N2,G] = size(F);
% starting values
if strcmp(start,'manova')
    % find initial estimates through MANOVA
    [dd,pp,stats] = manova1(X,max(F.*(ones(size(F,1),1)*[1:G]),[],2));
    B0=stats.eigenvec(:,1:M);
    [B0,T]=rotate2echelon(B0);
    Z0=(F'*F)\F'*X*B0;
    b=[];for m=1:M;b=[b;B0(m:p,m)];end
    pars0=[b;Z0(:)];
    clear dd pp stats
elseif strcmp(start,'ca')
    [XX,SV,YY,sstotal,ssfitted,ssres]=ca(F,1,1,M,X,eye(G));
    s=(prod(diag(SV))).^(1/M);SV=SV./s;
    B0=inv(X'*X)*X'*(s*XX);
    [B0,T]=rotate2echelon(B0);
    b=[];for m=1:M;b=[b;B0(m:p,m)];end
    Z0= YY*SV*T;
    pars0=[b;Z0(:)];
    clear b XX SV YY B0 T Z0 sstotal ssfitted ssres
else
    % starting values have been given
    pars0=start;
end
% set optimizatiopn options
options = optimset('OutputFcn',@checkfval,'LargeScale', 'off','display', 'iter',...
    'Maxiter', 1000,'MaxFunEvals',100000);
%options = optimset('OutputFcn',@checkfval,'LargeScale', 'off','display', 'off',...
%    'Maxiter', 1000,'MaxFunEvals',100000);

if M>1 & (M*(M+1)-(G-1))>(M*(M-1)/2)% if M==1 solution is identified
    [pars,LL,exitflag,output,grad,hessian]= fminunc(@loglik,pars0,options,X,F,n,G,p,M);
else
    [pars,LL,exitflag,output]= fminunc(@loglik,pars0,options,X,F,n,G,p,M);
end
% get parameters
b=pars(1:p*M-M*(M-1)/2);B=zeros(p,M);
for m=1:M;B(:,m)=[zeros(m-1,1);b((m-1)*p+1-(m-1)*(m-2)/2:m*p-m*(m-1)/2)];end
z=pars(p*M-M*(M-1)/2+1:end);Z=reshape(z,[G,M]);
% get coordinates
Y=X*B;
%---------IDENTIFY SOLUTION ------------------------------------
if M>1 & (M*(M+1)-(G-1))>(M*(M-1)/2)% if M==1 solution is identified
if M<(G-1)
    D2=unfdist2(Y,Z);DJ=D2*(eye(G)-ones(G)./G);
    [U,Dc,V]=svd(DJ,0);
%    Dc=Dc(1:m+1,1:m+1);U=U(:,1:m+1)*sqrt(Dc);V=V(:,1:m+1)*sqrt(Dc);% distribution of singular values matter
    Dc=Dc(1:m+1,1:m+1);U=U(:,1:m+1);V=V(:,1:m+1)*Dc;
%    Dc=Dc(1:m+1,1:m+1);U=U(:,1:m+1)*Dc;V=V(:,1:m+1);
    % solving for t1 and T2
    % set things for FSOLVE options and starting values
    options2 = optimset('LargeScale', 'off', 'NonlEqnAlgorithm', 'lm',...
             'display', 'iter','Maxiter', 10000, 'MaxFunEvals', 1e20);
%    options2 = optimset('LargeScale', 'off', 'NonlEqnAlgorithm', 'lm',...
%             'display', 'none','Maxiter', 10000, 'MaxFunEvals', 1e20);
    T0=eye(m+1);
    [T]= fsolve(@funzero2,T0,options2,U,V);
    S=(inv(T))';
    % find coordinate matrices
    Y=-.5*U*T(:,2:end);Z=V*S(:,2:end);
    %mY=mean(Y);Y=Y-ones(n,1)*mY;Z=Z-ones(G,1)*mY;
    B=([ones(N1,1) X]'*[ones(N1,1) X])\[ones(N1,1) X]'*Y;
    Z=Z-ones(G,1)*B(1,:);B=B(2:end,:);
elseif M==(G-1)
    [U,S,V]=svd(Y,0);
    T=V/(S./sqrt(n));
    B=B*T;
    ZT=Z*(inv(T))';
    pars0=[zeros(M+1,1)];
%    options3 = optimset('LargeScale', 'off', 'NonlEqnAlgorithm', 'lm',...
%                     'display', 'none','Maxiter', 100000, 'MaxFunEvals', 1e20);
    options3 = optimset('LargeScale', 'off', 'NonlEqnAlgorithm', 'lm',...
                     'display', 'iter','Maxiter', 100000, 'MaxFunEvals', 1e20);
    [pars,fval,exitflag,output]= fsolve(@funzero,pars0,options3,Z,ZT,M,G);
    Y=U*sqrt(n);
    Z=ones(G,1)*pars(1:M)'+ZT;
end
% ------------get GRADIENT AND HESSIAN ---------------------------
%options1 = optimset('OutputFcn',@checkfval,'LargeScale', 'off','display', 'none',...
%    'Maxiter', 0,'MaxFunEvals',100000);
options1 = optimset('OutputFcn',@checkfval,'LargeScale', 'off','display', 'iter',...
    'Maxiter', 0,'MaxFunEvals',100000);
[B,T]=rotate2echelon(B);Z=Z*T;b=[];for m=1:M;b=[b;B(m:p,m)];end;
pars0=[b;Z(:)];
[pars,LL,exitflag,output,grad,hessian]= fminunc(@loglik,pars0,options1,X,F,n,G,p,M);
b=pars(1:p*M-M*(M-1)/2);B=zeros(p,M);
for m=1:M;B(:,m)=[zeros(m-1,1);b((m-1)*p+1-(m-1)*(m-2)/2:m*p-m*(m-1)/2)];end
z=[pars(p*M-M*(M-1)/2+1:end)];Z=reshape(z,[G,M]);
Y=X*B;
end %line48
% put results in structure
results.w=ones(G,1);
results.B=B;
results.Y=Y;
results.Z=Z;
results.parameters=pars;
results.loglik=-LL;
results.npar=(p+G)*M-max(M.*(M-1)./2,M.*(M+1)-(G-1));
results.BIC = 2*LL+log(n)*results.npar;
results.grad = grad;
results.hessian = hessian;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% help functions%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    function LL=loglik(pars,X,F,N,G,p,M)
    b=pars(1:p*M-M*(M-1)/2);B=zeros(p,M);
    for m=1:M;B(:,m)=[zeros(m-1,1);b((m-1)*p+1-(m-1)*(m-2)/2:m*p-m*(m-1)/2)];end
    z=pars(p*M-M*(M-1)/2+1:end);Z=reshape(z,[G,M]);
    P0 = exp(-unfdist2(X*B,Z));
    P = P0./(sum(P0,2)*ones(1,G));
    LL=-sum(sum(F.*log(max(P,realmin))));
    end %%loglik
    
    function D2 = unfdist2(Y1,Y2)
    D2=diag(Y1*Y1')*ones(1,size(Y2,1))+ones(size(Y1,1),1)*diag(Y2*Y2')'-2*Y1*Y2';
    end %unfdist2

    function stop = checkfval(x,optimValues,state,pars,X,F,N,G,p)
    stop = false;
    % Check if loglikelihood is infinite
    if isnan(optimValues.directionalderivative); stop = true;end 
    end % checkfval

    function fval = funzero2(T,U,V)
        S=inv(T)';VS=V*S;
        fval1 = diag(VS(:,2:end)*VS(:,2:end)')-VS(:,1)-mean(diag(VS(:,2:end)*VS(:,2:end)'));
        fval2 = U*T(:,1)-ones(size(U,1),1);
        fval = [fval1;fval2];
    end %funzero2 for M <= G-1

    function fval = funzero(pars,Z,ZT,M,G)
        fval = diag(Z*Z')-diag((ones(G,1)*pars(1:M)'+ZT)*(ones(G,1)*pars(1:M)'+ZT)')-pars(M+1).*ones(G,1);%
    end %funzero for maximum dims

    function [X,T]= rotate2echelon(X)
    % rotate2echelon finds a rotation such that the upper triangle of a
    % matrix is 0
    [p,ndim]=size(X);
    T=eye(ndim);
    for t1=1:ndim-1
        for t2=t1+1:ndim
             rad=sqrt(sum(X(t1,[t1 t2]).^2));
             R=zeros(ndim);
             R(t1,t1) = X(t1,t1)./rad;  
             R(t1,t2) =-X(t1,t2)./rad;
             R(t2,t1) = X(t1,t2)./rad;
             R(t2,t2) = X(t1,t1)./rad;
             R=R+(diag(diag(R)==0));
             X=X*R;
             T=T*R;
        end
    end
    end% rotate2echelon

end %ipcm1_transitional

